/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2006      by Monami Software Limited Partnership, JAPAN
 *  Copyright (C) 2004-2007 by Embedded and Real-Time Systems Laboratory
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: prc_sil.h 1157 2008-06-26 03:10:08Z ertl-yutaka $
 */

/*
 *	sil.hΥץå¸M32Rѡ
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

#ifndef TOPPERS_MACRO_ONLY

/*
 *  NMI٤Ƥγߤζػ
 */
Inline void
TOPPERS_disint(void)
{
	uint32_t	psw;

	Asm("mvfc %0, psw" : "=r"(psw));
	psw &= 0xffbf;
	Asm("mvtc %0, psw" : : "r"(psw));
}

/*
 *  ߥåβ
 */
Inline void
TOPPERS_enaint(void)
{
	uint32_t	psw;
	
	Asm("mvfc %0, psw" : "=r"(psw));
	psw |= 0x40;	
	Asm("mvtc %0, psw" : : "r"(psw));
}

/*
 *  ߥå֤
 */
#define SIL_PRE_LOC		
#define SIL_LOC_INT()	((void)(TOPPERS_disint()))
#define SIL_UNL_INT()	((void)(TOPPERS_enaint()))

/*
 *  Ԥ
 */
Inline void
sil_dly_nse(ulong_t dlytim)
{
	register uint32_t r0 asm("r0") = (uint32_t) dlytim;
	Asm("bl _sil_dly_nse" : "=g"(r0) : "0"(r0) : "r14" );
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ץåΥǥ
 */
#define SIL_ENDIAN_BIG				/* ӥåǥ */

#endif /* TOPPERS_PRC_SIL_H */
